"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFetchpBuilder = exports.default = exports.useFetchp = exports.FetchpStatus = void 0;
const deps_external_js_1 = require("./deps-external.js");
const fetchp_js_1 = require("./fetchp.js");
Object.defineProperty(exports, "FetchpStatus", { enumerable: true, get: function () { return fetchp_js_1.FetchpStatus; } });
const useFetchpBuilder = function useFetchpBuilder(fetchpInstance) {
    // deno-lint-ignore no-explicit-any
    return function useFetchp(method, uri, init) {
        const [data, setData] = deps_external_js_1.React.useState();
        const [status, setStatus] = deps_external_js_1.React.useState(fetchp_js_1.FetchpStatus.IDLE);
        // deno-lint-ignore no-explicit-any
        const [error, setError] = deps_external_js_1.React.useState();
        const [result, setResult] = deps_external_js_1.React.useState();
        const [doFetch, setDoFetch] = deps_external_js_1.React.useState(undefined);
        deps_external_js_1.React.useEffect(() => {
            if (doFetch === undefined) {
                return;
            }
            const fetchData = async function fetchData() {
                // try {
                //   const result = fetchpInstance.request<T>(method, uri, {
                //     ...(init ?? {}),
                //     immediate: true,
                //     statusCallback: (newStatus) => {
                //       setStatus(newStatus);
                //     },
                //     errorCallback: (newError) => setError(newError),
                //     successCallback: (newData) => setData(newData),
                //     // cancelCallback: () => {},
                //   });
                var _a, _b, _c;
                //   setResult(result);
                // } catch (error) {
                //   setError(error);
                //   console.error(error);
                //   setStatus(FetchpStatus.ERROR);
                // }
                setError(undefined);
                setStatus(fetchp_js_1.FetchpStatus.FETCHING);
                try {
                    const finalInit = Object.assign(Object.assign(Object.assign({}, (init !== null && init !== void 0 ? init : {})), ((_a = doFetch[0]) !== null && _a !== void 0 ? _a : {})), { immediate: true });
                    const result = fetchpInstance.request(method, uri, finalInit);
                    setResult(result);
                    (_b = doFetch[1]) === null || _b === void 0 ? void 0 : _b.call(doFetch, result);
                    const localData = await result.data;
                    setData(localData);
                    if (result.abortController.signal.aborted) {
                        setStatus(fetchp_js_1.FetchpStatus.CANCELED);
                    }
                    else {
                        setStatus(fetchp_js_1.FetchpStatus.SUCCESS);
                    }
                }
                catch (error) {
                    setError(error);
                    (_c = doFetch[2]) === null || _c === void 0 ? void 0 : _c.call(doFetch, error);
                    console.error(error);
                    setStatus(fetchp_js_1.FetchpStatus.ERROR);
                }
            };
            fetchData();
        }, [doFetch]);
        return {
            doFetch: (init) => new Promise((resolve, reject) => setDoFetch([init, resolve, reject])),
            data,
            status,
            isIdle: status === fetchp_js_1.FetchpStatus.IDLE,
            isFetching: status === fetchp_js_1.FetchpStatus.FETCHING,
            isLoading: status === fetchp_js_1.FetchpStatus.LOADING,
            isError: status === fetchp_js_1.FetchpStatus.ERROR,
            isCanceled: status === fetchp_js_1.FetchpStatus.CANCELED,
            isSuccess: status === fetchp_js_1.FetchpStatus.SUCCESS,
            error,
            result,
        };
    };
};
exports.useFetchpBuilder = useFetchpBuilder;
const useFetchp = useFetchpBuilder(fetchp_js_1.fetchp);
exports.useFetchp = useFetchp;
exports.default = useFetchp;
